<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>lib.plot.tools &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      <li>lib.plot.tools</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for lib.plot.tools</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module that defines tools for plots, such as</span>

<span class="sd">* Generate figure and axes</span>
<span class="sd">* Save a plot</span>
<span class="sd">* Change how the plot looks (e.g., grid, ...)</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>
<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span><span class="p">,</span> <span class="n">List</span><span class="p">,</span> <span class="n">Tuple</span>
<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="n">ceil</span>

<span class="kn">import</span> <span class="nn">matplotlib</span> <span class="k">as</span> <span class="nn">mpl</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>

<span class="kn">from</span> <span class="nn">..inout.serial</span> <span class="kn">import</span> <span class="n">try_makedirs</span>
<span class="kn">from</span> <span class="nn">.._typing</span> <span class="kn">import</span> <span class="n">ArrayLike</span>


<div class="viewcode-block" id="show_grid"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.show_grid">[docs]</a><span class="k">def</span> <span class="nf">show_grid</span><span class="p">(</span><span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axis</span><span class="o">.</span><span class="n">Axis</span><span class="p">,</span> <span class="n">which</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;major&#39;</span><span class="p">,</span> <span class="n">axis</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;both&#39;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Enable a standard grid.</span>

<span class="sd">    Args:</span>
<span class="sd">        ax:  axis where to show the grid</span>
<span class="sd">        which : ``both``, ``major`` or ``minor``, which grid to show</span>
<span class="sd">        axis : ``x``, ``y`` or ``both``, along which axis to show the grid</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">b</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="n">axis</span><span class="p">,</span> <span class="n">which</span><span class="o">=</span><span class="n">which</span><span class="p">,</span>
            <span class="n">color</span><span class="o">=</span><span class="s1">&#39;#666666&#39;</span><span class="p">,</span> <span class="n">linestyle</span><span class="o">=</span><span class="s1">&#39;-&#39;</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.2</span><span class="p">)</span></div>


<div class="viewcode-block" id="get_multi_fig_ax"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.get_multi_fig_ax">[docs]</a><span class="k">def</span> <span class="nf">get_multi_fig_ax</span><span class="p">(</span>
    <span class="n">nb_axes</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span>
    <span class="n">max_ncols</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">3</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">]]:</span>
    <span class="sd">&quot;&quot;&quot; Get the  fig and axes given the number of figures to plot and the</span>
<span class="sd">    maximum number of columns in the grid of figures.</span>

<span class="sd">    Args:</span>
<span class="sd">        nb_axes: number of axes required</span>
<span class="sd">        max_ncols: number of columns (max)</span>

<span class="sd">    Returns:</span>
<span class="sd">        :</span>

<span class="sd">        * fig: figure</span>
<span class="sd">        * axes: list of axes (flattened)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">ncols</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">max_ncols</span><span class="p">,</span> <span class="n">nb_axes</span><span class="p">)</span>
    <span class="n">nrows</span> <span class="o">=</span> <span class="n">ceil</span><span class="p">(</span><span class="n">nb_axes</span> <span class="o">/</span> <span class="n">ncols</span><span class="p">)</span>

    <span class="n">fig</span><span class="p">,</span> <span class="n">origin_axes</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span>
        <span class="n">ncols</span><span class="o">=</span><span class="n">ncols</span><span class="p">,</span>
        <span class="n">nrows</span><span class="o">=</span><span class="n">nrows</span><span class="p">,</span>
        <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">8</span><span class="o">*</span><span class="n">ncols</span><span class="p">,</span> <span class="mi">6</span><span class="o">*</span><span class="n">nrows</span><span class="p">)</span>
    <span class="p">)</span>

    <span class="k">if</span> <span class="p">(</span><span class="n">ncols</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span> <span class="ow">and</span> <span class="p">(</span><span class="n">nrows</span> <span class="o">==</span> <span class="mi">1</span><span class="p">):</span>
        <span class="n">axes</span> <span class="o">=</span> <span class="p">[</span><span class="n">origin_axes</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">axes</span> <span class="o">=</span> <span class="n">origin_axes</span><span class="o">.</span><span class="n">flat</span>

    <span class="k">for</span> <span class="n">iax</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nb_axes</span><span class="p">,</span> <span class="n">ncols</span> <span class="o">*</span> <span class="n">nrows</span><span class="p">):</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">delaxes</span><span class="p">(</span><span class="n">axes</span><span class="p">[</span><span class="n">iax</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span></div>


<div class="viewcode-block" id="get_fig_ax"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.get_fig_ax">[docs]</a><span class="k">def</span> <span class="nf">get_fig_ax</span><span class="p">(</span>
    <span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">orientation</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;vertical&#39;</span><span class="p">,</span>
    <span class="n">figsize</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Tuple</span><span class="p">[</span><span class="nb">float</span><span class="p">,</span> <span class="nb">float</span><span class="p">]]</span> <span class="o">=</span> <span class="kc">None</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">Tuple</span><span class="p">[</span><span class="n">Optional</span><span class="p">[</span><span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">],</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Return a figure and an axis in the case where ``ax`` is ``None``</span>

<span class="sd">    Args:</span>
<span class="sd">        ax : default axis</span>
<span class="sd">        orientation: ``vertical&#39; or &#39;horizontal``, orientation of the plot</span>
<span class="sd">        figsize: Size of the figure. Default depends on `orientation`</span>

<span class="sd">            * ``vertical``: default figure size is (8, 6)</span>
<span class="sd">            * ``horizontal``: default figure size is (6, 8)</span>

<span class="sd">    Returns:</span>
<span class="sd">        fig : figure of the plot (``None`` if ``ax`` was not ``None``)</span>
<span class="sd">        ax :  axis of the plot</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">ax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;vertical&#39;</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">figsize</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">figsize</span> <span class="o">=</span> <span class="p">(</span><span class="mi">8</span><span class="p">,</span> <span class="mi">6</span><span class="p">)</span>
            <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="n">figsize</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">orientation</span> <span class="o">==</span> <span class="s1">&#39;horizontal&#39;</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">figsize</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">figsize</span> <span class="o">=</span> <span class="p">(</span><span class="mi">6</span><span class="p">,</span> <span class="mi">8</span><span class="p">)</span>
            <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="n">figsize</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="n">ax</span></div>


<div class="viewcode-block" id="change_range_axis"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.change_range_axis">[docs]</a><span class="k">def</span> <span class="nf">change_range_axis</span><span class="p">(</span>
        <span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">,</span> <span class="n">factor_max</span><span class="p">:</span> <span class="nb">float</span> <span class="o">=</span> <span class="mf">1.1</span><span class="p">,</span> <span class="n">min_to_0</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">,</span>
        <span class="n">axis</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;y&#39;</span><span class="p">,</span> <span class="n">logscale</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; multiple the max range of an axis of a plot by ``factor``</span>

<span class="sd">    Args:</span>
<span class="sd">        ax : axis where to plot</span>
<span class="sd">        factor_max : factor by which xmax and/or ymax are/is multiplied</span>
<span class="sd">        min_at_0 whether the minimum value of the considered axis is set at 0</span>
<span class="sd">        axis : &#39;x&#39;, &#39;y&#39; or &#39;both&#39;, qxis where to change the range limits</span>
<span class="sd">        logscale : whether the y-axis is in logscale</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;x&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span><span class="p">:</span>
        <span class="n">xmin</span><span class="p">,</span> <span class="n">xmax</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">get_xlim</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">min_to_0</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">logscale</span><span class="p">:</span>
                <span class="n">xmin</span> <span class="o">=</span> <span class="mi">1</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">xmin</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">factor_max</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">xmax</span> <span class="o">=</span> <span class="n">xmax</span> <span class="o">*</span> <span class="n">factor_max</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">xmin</span><span class="p">,</span> <span class="n">xmax</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;y&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span><span class="p">:</span>
        <span class="n">ymin</span><span class="p">,</span> <span class="n">ymax</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">get_ylim</span><span class="p">()</span>
        <span class="k">if</span> <span class="n">min_to_0</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">logscale</span><span class="p">:</span>
                <span class="n">ymin</span> <span class="o">=</span> <span class="mi">1</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">ymin</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">factor_max</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">ymax</span> <span class="o">=</span> <span class="n">ymax</span> <span class="o">*</span> <span class="n">factor_max</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="n">ymin</span><span class="p">,</span> <span class="n">ymax</span><span class="p">)</span></div>


<div class="viewcode-block" id="set_log_scale"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.set_log_scale">[docs]</a><span class="k">def</span> <span class="nf">set_log_scale</span><span class="p">(</span><span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">,</span> <span class="n">axis</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;both&#39;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Set logscale to the specified axes</span>

<span class="sd">    Args:</span>
<span class="sd">        ax (matplotlib.axes.Axes): matplotlib `ax` of the figure</span>
<span class="sd">        axis (str):``both``, ``x`` or ``y`` axis, which axis or axes that will</span>
<span class="sd">            have a log-scale</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;x&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xscale</span><span class="p">(</span><span class="s1">&#39;log&#39;</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;y&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_yscale</span><span class="p">(</span><span class="s1">&#39;log&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="fix_ticks"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.fix_ticks">[docs]</a><span class="k">def</span> <span class="nf">fix_ticks</span><span class="p">(</span><span class="n">ax</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">axes</span><span class="o">.</span><span class="n">Axes</span><span class="p">,</span> <span class="n">ticks</span><span class="p">:</span> <span class="n">ArrayLike</span><span class="p">,</span>
              <span class="n">ticklabels</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="n">axis</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="s1">&#39;x&#39;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Fix the ticks of the x-axis</span>

<span class="sd">    Args:</span>
<span class="sd">        ax : matplotlib `ax` of the figure</span>
<span class="sd">        ticks: position of the ticks</span>
<span class="sd">        ticklabels: label of the ticks</span>
<span class="sd">        axis: ``both``, ``x`` or ``y`` axis, which axis or axes to act on</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;x&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xticks</span><span class="p">(</span><span class="n">ticks</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">ticklabels</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">(</span><span class="n">ticklabels</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;y&#39;</span> <span class="ow">or</span> <span class="n">axis</span> <span class="o">==</span> <span class="s1">&#39;both&#39;</span><span class="p">:</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_yticks</span><span class="p">(</span><span class="n">ticks</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">ticklabels</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_yticklabels</span><span class="p">(</span><span class="n">ticklabels</span><span class="p">)</span></div>


<div class="viewcode-block" id="save_fig"><a class="viewcode-back" href="../../../lib.plot.html#lib.plot.tools.save_fig">[docs]</a><span class="k">def</span> <span class="nf">save_fig</span><span class="p">(</span>
        <span class="n">fig</span><span class="p">:</span> <span class="n">mpl</span><span class="o">.</span><span class="n">figure</span><span class="o">.</span><span class="n">Figure</span><span class="p">,</span>
        <span class="n">path</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
        <span class="n">exts</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="n">tight_layout</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">True</span><span class="p">,</span>
        <span class="n">show</span><span class="p">:</span> <span class="nb">bool</span> <span class="o">=</span> <span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Save ``fig`` in ``{lib.loc.out_folder}/{path}/``,</span>
<span class="sd">    under the name ``name``, only if ``name`` is specified.</span>

<span class="sd">    Args:</span>
<span class="sd">        fig : figure to save</span>
<span class="sd">        name: name of the file to save</span>
<span class="sd">        path: path where to save the picture, without the extension</span>
<span class="sd">        exts: extension of the files (png, pdf, ...)</span>
<span class="sd">        tight_layout: apply :py:func:`matplotlib.pyplot.tight_layout`</span>
<span class="sd">        show: whether the figure is shown</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="n">exts</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">exts</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;png&#39;</span><span class="p">,</span> <span class="s1">&#39;pdf&#39;</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">tight_layout</span><span class="p">:</span>
        <span class="c1"># Match the borders of the images with the borders of the object</span>
        <span class="n">fig</span><span class="o">.</span><span class="n">tight_layout</span><span class="p">()</span>

    <span class="n">try_makedirs</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="n">path</span><span class="p">))</span>

    <span class="c1"># Save in pdf and png</span>
    <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">exts</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
        <span class="n">exts</span> <span class="o">=</span> <span class="p">[</span><span class="n">exts</span><span class="p">]</span>

    <span class="k">for</span> <span class="n">ext</span> <span class="ow">in</span> <span class="n">exts</span><span class="p">:</span>
        <span class="n">full_path</span> <span class="o">=</span> <span class="n">path</span> <span class="o">+</span> <span class="s2">&quot;.&quot;</span> <span class="o">+</span> <span class="n">ext</span>
        <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Fig saved in </span><span class="si">{full_path}</span><span class="s2">&quot;</span><span class="p">)</span>

        <span class="n">fig</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">full_path</span><span class="p">,</span> <span class="n">dpi</span><span class="o">=</span><span class="mi">300</span><span class="p">,</span> <span class="n">bbox_inches</span><span class="o">=</span><span class="s1">&#39;tight&#39;</span><span class="p">)</span>

    <span class="k">if</span> <span class="ow">not</span> <span class="n">show</span><span class="p">:</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">(</span><span class="n">fig</span><span class="p">)</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>